#!/bin/sh
#
# The purpose of this script is to fetch a PDB file from PDBs ftp
# server. An error code is returned if one or more of the entries are
# not found.
# Usage: pdbget.sh ent1 [ent2 ent3 ...]
#
# Copyright 2011 Morten Kjeldgaard
#
# pdbget.sh is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This script is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this script.  If not, see <http://www.gnu.org/licenses/>.
#
# 20110120    mok   Created.

SERVER=www.pdb.org
stat=0

for e in $* ; do
    echo -n $e
    if [ -s $e.pdb ] ; then
	echo -n " [\033[1;32mEXISTS\033[0;39m] "
    else
        wget -q http://${SERVER}/pdb/files/$e.pdb.gz -O $e.pdb.gz
        status=$?
        if [ $status = 0 ] ; then
	    gunzip -f $e.pdb.gz
	    echo -n " [\033[1;32mOK\033[0;39m] "
        else
	    echo -n " [\033[1;31mFAIL\033[0;39m] "
	    stat=1
        fi
    fi
done
echo
return $stat
